package fr.ippon.jhipster.cellar.domain;

import org.hibernate.annotations.Cache;
import org.hibernate.annotations.CacheConcurrencyStrategy;

import javax.persistence.*;
import java.io.Serializable;
import java.time.LocalDate;
import java.util.Objects;

/**
 * A Bottle.
 */
@Entity
@Table(name = "bottle")
@Cache(usage = CacheConcurrencyStrategy.NONSTRICT_READ_WRITE)
public class Bottle implements Serializable {

    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    @Column(name = "name")
    private String name;

    @Column(name = "created_at")
    private LocalDate createdAt;

    @Column(name = "yrow")
    private Integer yrow;

    @Column(name = "xcolumn")
    private Integer xcolumn;

    @Column(name = "flipped")
    private Boolean flipped;

    @ManyToOne
    private Rack rack;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public Bottle name(String name) {
        this.name = name;
        return this;
    }

    public void setName(String name) {
        this.name = name;
    }

    public LocalDate getCreatedAt() {
        return createdAt;
    }

    public Bottle createdAt(LocalDate createdAt) {
        this.createdAt = createdAt;
        return this;
    }

    public void setCreatedAt(LocalDate createdAt) {
        this.createdAt = createdAt;
    }

    public Integer getYrow() {
        return yrow;
    }

    public Bottle yrow(Integer yrow) {
        this.yrow = yrow;
        return this;
    }

    public void setYrow(Integer yrow) {
        this.yrow = yrow;
    }

    public Integer getXcolumn() {
        return xcolumn;
    }

    public Bottle xcolumn(Integer xcolumn) {
        this.xcolumn = xcolumn;
        return this;
    }

    public void setXcolumn(Integer xcolumn) {
        this.xcolumn = xcolumn;
    }

    public Boolean isFlipped() {
        return flipped;
    }

    public Bottle flipped(Boolean flipped) {
        this.flipped = flipped;
        return this;
    }

    public void setFlipped(Boolean flipped) {
        this.flipped = flipped;
    }

    public Rack getRack() {
        return rack;
    }

    public Bottle rack(Rack rack) {
        this.rack = rack;
        return this;
    }

    public void setRack(Rack rack) {
        this.rack = rack;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        Bottle bottle = (Bottle) o;
        if (bottle.getId() == null || getId() == null) {
            return false;
        }
        return Objects.equals(getId(), bottle.getId());
    }

    @Override
    public int hashCode() {
        return Objects.hashCode(getId());
    }

    @Override
    public String toString() {
        return "Bottle{" +
            "id=" + getId() +
            ", name='" + getName() + "'" +
            ", createdAt='" + getCreatedAt() + "'" +
            ", yrow='" + getYrow() + "'" +
            ", xcolumn='" + getXcolumn() + "'" +
            ", flipped='" + isFlipped() + "'" +
            "}";
    }
}
