import { Component, OnInit, OnDestroy } from '@angular/core';
import { ActivatedRoute } from '@angular/router';

import { NgbActiveModal, NgbModalRef } from '@ng-bootstrap/ng-bootstrap';
import { EventManager } from 'ng-jhipster';

import { Bottle } from './bottle.model';
import { BottlePopupService } from './bottle-popup.service';
import { BottleService } from './bottle.service';

@Component({
    selector: 'jhi-bottle-delete-dialog',
    templateUrl: './bottle-delete-dialog.component.html'
})
export class BottleDeleteDialogComponent {

    bottle: Bottle;

    constructor(
        private bottleService: BottleService,
        public activeModal: NgbActiveModal,
        private eventManager: EventManager
    ) {
    }

    clear() {
        this.activeModal.dismiss('cancel');
    }

    confirmDelete(id: number) {
        this.bottleService.delete(id).subscribe((response) => {
            this.eventManager.broadcast({
                name: 'bottleListModification',
                content: 'Deleted an bottle'
            });
            this.activeModal.dismiss(true);
        });
    }
}

@Component({
    selector: 'jhi-bottle-delete-popup',
    template: ''
})
export class BottleDeletePopupComponent implements OnInit, OnDestroy {

    modalRef: NgbModalRef;
    routeSub: any;

    constructor(
        private route: ActivatedRoute,
        private bottlePopupService: BottlePopupService
    ) {}

    ngOnInit() {
        this.routeSub = this.route.params.subscribe((params) => {
            this.modalRef = this.bottlePopupService
                .open(BottleDeleteDialogComponent, params['id']);
        });
    }

    ngOnDestroy() {
        this.routeSub.unsubscribe();
    }
}
