import { Component, OnInit, OnDestroy } from '@angular/core';
import { ActivatedRoute } from '@angular/router';
import { Subscription } from 'rxjs/Rx';
import { EventManager  } from 'ng-jhipster';

import { Bottle } from './bottle.model';
import { BottleService } from './bottle.service';

@Component({
    selector: 'jhi-bottle-detail',
    templateUrl: './bottle-detail.component.html'
})
export class BottleDetailComponent implements OnInit, OnDestroy {

    bottle: Bottle;
    private subscription: Subscription;
    private eventSubscriber: Subscription;

    constructor(
        private eventManager: EventManager,
        private bottleService: BottleService,
        private route: ActivatedRoute
    ) {
    }

    ngOnInit() {
        this.subscription = this.route.params.subscribe((params) => {
            this.load(params['id']);
        });
        this.registerChangeInBottles();
    }

    load(id) {
        this.bottleService.find(id).subscribe((bottle) => {
            this.bottle = bottle;
        });
    }
    previousState() {
        window.history.back();
    }

    ngOnDestroy() {
        this.subscription.unsubscribe();
        this.eventManager.destroy(this.eventSubscriber);
    }

    registerChangeInBottles() {
        this.eventSubscriber = this.eventManager.subscribe(
            'bottleListModification',
            (response) => this.load(this.bottle.id)
        );
    }
}
