import { Injectable, Component } from '@angular/core';
import { Router } from '@angular/router';
import { NgbModal, NgbModalRef } from '@ng-bootstrap/ng-bootstrap';
import { Bottle } from './bottle.model';
import { BottleService } from './bottle.service';
@Injectable()
export class BottlePopupService {
    private isOpen = false;
    constructor(
        private modalService: NgbModal,
        private router: Router,
        private bottleService: BottleService

    ) {}

    open(component: Component, id?: number | any): NgbModalRef {
        if (this.isOpen) {
            return;
        }
        this.isOpen = true;

        if (id) {
            this.bottleService.find(id).subscribe((bottle) => {
                if (bottle.createdAt) {
                    bottle.createdAt = {
                        year: bottle.createdAt.getFullYear(),
                        month: bottle.createdAt.getMonth() + 1,
                        day: bottle.createdAt.getDate()
                    };
                }
                this.bottleModalRef(component, bottle);
            });
        } else {
            return this.bottleModalRef(component, new Bottle());
        }
    }

    bottleModalRef(component: Component, bottle: Bottle): NgbModalRef {
        const modalRef = this.modalService.open(component, { size: 'lg', backdrop: 'static'});
        modalRef.componentInstance.bottle = bottle;
        modalRef.result.then((result) => {
            this.router.navigate([{ outlets: { popup: null }}], { replaceUrl: true });
            this.isOpen = false;
        }, (reason) => {
            this.router.navigate([{ outlets: { popup: null }}], { replaceUrl: true });
            this.isOpen = false;
        });
        return modalRef;
    }
}
