import { Injectable } from '@angular/core';
import { Resolve, ActivatedRouteSnapshot, RouterStateSnapshot, Routes, CanActivate } from '@angular/router';

import { UserRouteAccessService } from '../../shared';
import { PaginationUtil } from 'ng-jhipster';

import { BottleComponent } from './bottle.component';
import { BottleDetailComponent } from './bottle-detail.component';
import { BottlePopupComponent } from './bottle-dialog.component';
import { BottleDeletePopupComponent } from './bottle-delete-dialog.component';

import { Principal } from '../../shared';

export const bottleRoute: Routes = [
    {
        path: 'bottle',
        component: BottleComponent,
        data: {
            authorities: ['ROLE_USER'],
            pageTitle: 'Bottles'
        },
        canActivate: [UserRouteAccessService]
    }, {
        path: 'bottle/:id',
        component: BottleDetailComponent,
        data: {
            authorities: ['ROLE_USER'],
            pageTitle: 'Bottles'
        },
        canActivate: [UserRouteAccessService]
    }
];

export const bottlePopupRoute: Routes = [
    {
        path: 'bottle-new',
        component: BottlePopupComponent,
        data: {
            authorities: ['ROLE_USER'],
            pageTitle: 'Bottles'
        },
        canActivate: [UserRouteAccessService],
        outlet: 'popup'
    },
    {
        path: 'bottle/:id/edit',
        component: BottlePopupComponent,
        data: {
            authorities: ['ROLE_USER'],
            pageTitle: 'Bottles'
        },
        canActivate: [UserRouteAccessService],
        outlet: 'popup'
    },
    {
        path: 'bottle/:id/delete',
        component: BottleDeletePopupComponent,
        data: {
            authorities: ['ROLE_USER'],
            pageTitle: 'Bottles'
        },
        canActivate: [UserRouteAccessService],
        outlet: 'popup'
    }
];
