import { Component, OnInit, OnDestroy } from '@angular/core';
import { ActivatedRoute } from '@angular/router';

import { NgbActiveModal, NgbModalRef } from '@ng-bootstrap/ng-bootstrap';
import { EventManager } from 'ng-jhipster';

import { Rack } from './rack.model';
import { RackPopupService } from './rack-popup.service';
import { RackService } from './rack.service';

@Component({
    selector: 'jhi-rack-delete-dialog',
    templateUrl: './rack-delete-dialog.component.html'
})
export class RackDeleteDialogComponent {

    rack: Rack;

    constructor(
        private rackService: RackService,
        public activeModal: NgbActiveModal,
        private eventManager: EventManager
    ) {
    }

    clear() {
        this.activeModal.dismiss('cancel');
    }

    confirmDelete(id: number) {
        this.rackService.delete(id).subscribe((response) => {
            this.eventManager.broadcast({
                name: 'rackListModification',
                content: 'Deleted an rack'
            });
            this.activeModal.dismiss(true);
        });
    }
}

@Component({
    selector: 'jhi-rack-delete-popup',
    template: ''
})
export class RackDeletePopupComponent implements OnInit, OnDestroy {

    modalRef: NgbModalRef;
    routeSub: any;

    constructor(
        private route: ActivatedRoute,
        private rackPopupService: RackPopupService
    ) {}

    ngOnInit() {
        this.routeSub = this.route.params.subscribe((params) => {
            this.modalRef = this.rackPopupService
                .open(RackDeleteDialogComponent, params['id']);
        });
    }

    ngOnDestroy() {
        this.routeSub.unsubscribe();
    }
}
