import { Component, OnInit, OnDestroy } from '@angular/core';
import { ActivatedRoute } from '@angular/router';
import { Subscription } from 'rxjs/Rx';
import { EventManager  } from 'ng-jhipster';

import { Rack } from './rack.model';
import { RackService } from './rack.service';

@Component({
    selector: 'jhi-rack-detail',
    templateUrl: './rack-detail.component.html'
})
export class RackDetailComponent implements OnInit, OnDestroy {

    rack: Rack;
    private subscription: Subscription;
    private eventSubscriber: Subscription;

    constructor(
        private eventManager: EventManager,
        private rackService: RackService,
        private route: ActivatedRoute
    ) {
    }

    ngOnInit() {
        this.subscription = this.route.params.subscribe((params) => {
            this.load(params['id']);
        });
        this.registerChangeInRacks();
    }

    load(id) {
        this.rackService.find(id).subscribe((rack) => {
            this.rack = rack;
        });
    }
    previousState() {
        window.history.back();
    }

    ngOnDestroy() {
        this.subscription.unsubscribe();
        this.eventManager.destroy(this.eventSubscriber);
    }

    registerChangeInRacks() {
        this.eventSubscriber = this.eventManager.subscribe(
            'rackListModification',
            (response) => this.load(this.rack.id)
        );
    }
}
