import { ComponentFixture, TestBed, async, inject } from '@angular/core/testing';
import { OnInit } from '@angular/core';
import { DatePipe } from '@angular/common';
import { ActivatedRoute } from '@angular/router';
import { Observable } from 'rxjs/Rx';
import { DateUtils, DataUtils, EventManager } from 'ng-jhipster';
import { JhipstercellarTestModule } from '../../../test.module';
import { MockActivatedRoute } from '../../../helpers/mock-route.service';
import { RackDetailComponent } from '../../../../../../main/webapp/app/entities/rack/rack-detail.component';
import { RackService } from '../../../../../../main/webapp/app/entities/rack/rack.service';
import { Rack } from '../../../../../../main/webapp/app/entities/rack/rack.model';

describe('Component Tests', () => {

    describe('Rack Management Detail Component', () => {
        let comp: RackDetailComponent;
        let fixture: ComponentFixture<RackDetailComponent>;
        let service: RackService;

        beforeEach(async(() => {
            TestBed.configureTestingModule({
                imports: [JhipstercellarTestModule],
                declarations: [RackDetailComponent],
                providers: [
                    DateUtils,
                    DataUtils,
                    DatePipe,
                    {
                        provide: ActivatedRoute,
                        useValue: new MockActivatedRoute({id: 123})
                    },
                    RackService,
                    EventManager
                ]
            }).overrideComponent(RackDetailComponent, {
                set: {
                    template: ''
                }
            }).compileComponents();
        }));

        beforeEach(() => {
            fixture = TestBed.createComponent(RackDetailComponent);
            comp = fixture.componentInstance;
            service = fixture.debugElement.injector.get(RackService);
        });


        describe('OnInit', () => {
            it('Should call load all on init', () => {
            // GIVEN

            spyOn(service, 'find').and.returnValue(Observable.of(new Rack(10)));

            // WHEN
            comp.ngOnInit();

            // THEN
            expect(service.find).toHaveBeenCalledWith(123);
            expect(comp.rack).toEqual(jasmine.objectContaining({id:10}));
            });
        });
    });

});
